explain_shmat_or_die(3)

NAME
explain_shmat_or_die - shared memory attach and report errors
    "shared memory attach and report errors"

SYNOPSIS
#include <libexplain/shmat.h>

void *explain_shmat_or_die(int shmid, const void *shmaddr, int shmflg);
void *explain_shmat_on_error(int shmid, const void *shmaddr, int shmflg);

DESCRIPTION
The explain_shmat_or_die function is used to call the shmat(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_shmat(3) function, and then the process terminates by calling exit(EXIT_FAILURE).

The explain_shmat_on_error function is used to call the shmat(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_shmat(3) function, but still returns to the caller.

shmid
    The shmid, exactly as to be passed to the shmat(2) system call.

shmaddr
    The shmaddr, exactly as to be passed to the shmat(2) system call.

shmflg
    The shmflg, exactly as to be passed to the shmat(2) system call.

RETURN VALUE
The explain_shmat_or_die function only returns on success, see shmat(2) for more information. On failure, prints an explanation and exits, it does not return.

The explain_shmat_on_error function always returns the value return by the wrapped shmat(2) system call.

EXAMPLE
The explain_shmat_or_die function is intended to be used in a fashion similar to the following example:
    void *result = explain_shmat_or_die(shmid, shmaddr, shmflg);

SEE ALSO

shmat(2)
    shared memory attach

explain_shmat(3)
    explain shmat(2) errors

exit(2)
    terminate the calling process

COPYRIGHT
libexplain version 1.2
Copyright (C) 2011 Peter Miller